<?php
include "pclzip.lib.php";

$version = "0.2beta";
$copyright = "Version " . $version . " <br /> Copyright by tFF &copy; 2006";

class	zipIt {
	var $dirlist;
	var $zipname;
	var $pclzip;
	var $filelist;
	var $result;

	/********************************************************************
	* constructor
	*
	*/
	function zipIt($zipname) {
		if (isset($zipname)) {
			$this->zipname = $zipname;
			$this->pclzip = new PclZip($this->zipname);
		} else {
			return false;
		}
	}

	/********************************************************************
	*
	*
	*/
	function getDirList ($_dirstr='.') {
//		$exclude_files = array('.', '..', 'pclzip.lib.php', 'zipit.php' );

		$this->dirlist = array();
		if (!is_dir($_dirstr)) {die("Error: no such directory.");}
		$cwd = getcwd();
		chdir($_dirstr);

		if (!$dirhandle=opendir('.')) {die("Error: Cannot open the directory.");}
		$idx=0;
		while (false !== ($filename=readdir($dirhandle))) {
			$type = (is_dir($filename) ? "dir" : (is_link($filename) ? "lnk" : "file"));
			$this->dirlist[$idx++] = array('name'=>$filename, 'type'=>$type);
		}
		closedir($dirhandle);
		chdir($cwd);
		$this->dirlist = $this->sortList($this->dirlist);

/*		foreach ($this->dirlist as $dir_key=>$dir_val) {
			for ($i=0; $i < count($exclude_files); $i++) {
				if ($dir_val['name']==$exclude_files[$i]) {
					unset($this->dirlist[$dir_key]);
					break;
				}
			}
		}
		$this->dirlist=array_values($this->dirlist);
*/	}

	/********************************************************************
	*
	*
	*/
	function storeFiles () {
		$this->result = $this->pclzip->create($this->filelist);
	}

	/********************************************************************
	*
	*
	*/
	function extractFiles ($dirstr='.') {
		$this->result = $this->pclzip->extract($dirstr);
	}

	/************************************************
	* filename match fucntion
	* In:	patternvar	- wildcards are allowed
	*	filename	- filename for comparison
	*************************************************/
	function fnmatch ($patternvar, $file) {
		if (gettype($patternvar) == "array") {
			foreach ($patternvar as $pattern) {
				if (stristr($pattern, "*")||stristr($pattern, "[")||stristr($pattern, "?")) {
					$result = $this->fnmatch_recurse ($pattern, $file);
				} else {
					$result = $pattern<>$file?false:true;
				}
				if ($result) return true;
			}
			return false;
		} else {
			$pattern = $pattern_var;
				if (stristr($pattern, "*")||stristr($pattern, "[")||stristr($pattern, "?")) {
					return ($this->fnmatch_recurse ($pattern, $file));
				} else {
					return ($pattern<>$file?false:true);
				}
		}
	}

  		// POSIX fnmatch analogue
		function fnmatch_recurse($pattern, $string) {
  			for ($op = 0, $npattern = '', $n = 0, $l = strlen($pattern); $n < $l; $n++) {
				switch ($c = $pattern[$n]) {
					case '\\':
					$npattern .= '\\' . @$pattern[++$n];
					break;
					case '.': case '+': case '^': case '$': case '(': case ')': case '{': case '}': case '=': case '!': case '<': case '>': case '|':
					$npattern .= '\\' . $c;
					break;
					case '?': case '*':
					$npattern .= '.' . $c;
					break;
					case '[': case ']': default:
					$npattern .= $c;

					if ($c == '[') {
						$op++;
					} else if ($c == ']') {
						if ($op == 0) return false;
						$op--;
					}
					break;
				}
			}
			if ($op != 0) return false;
			return preg_match('/^' . $npattern . '$/i', $string);
		}

	/********************************************************************
	*
	* out: return array - sorted array
	*/
	function sortList () {
		$dirs = array();
		$files = array();

	// separate dirs and files
		for ($a=0, $b=0, $c=0; $a<count($this->dirlist); $a++) {
			if ($this->dirlist[$a]['type']=='dir') {
				$dirs[$b++]=$this->dirlist[$a];
			} else {
				$files[$c++]=$this->dirlist[$a];
			}
		}
		// sort 'em
		if ( !empty($dirs) ) {usort($dirs, array("zipIt","ascSortSub"));};
		if ( !empty($files) ) {usort($files, array("zipIt","ascSortSub"));};
		// concatenate 'em sorted (dirs come first)
		for ($a=0, $b=0, $c=0; $a<count($this->dirlist); $a++) {
			if ($b<count($dirs)) {
				$newlist[$a]=$dirs[$b++];
			} elseif ($c<count($files)) {
				$newlist[$a]=$files[$c++];
			}
		}
		return ($newlist);
	}

			/********************************************************************
			* user defined sort
			* ascending
			*/
			function ascSortSub ($a, $b) {
				$al=strtolower($a["name"]); $bl=strtolower($b["name"]);
				return $al==$bl?0:($al<$bl?-1:1);
			}


	/********************************************************************
	* Remove Files and directories (recursively)
	* in:	directory - directory to work in
	*	filelist - list of files to remove (if empty then this::filelist will be used)
	* out:	TRUE/FALSE
	*/
	function rmFiles ($_dirstr = '.', $_flist='') {
		if( !empty($this->filelist) || !empty($_flist) ) {
			$_flist = (!empty($_flist)) ? $_flist : $this->filelist;
			foreach( $_flist as $v ) {
				$v = $_dirstr . '/' . $v;
				if( is_dir($v) ) {
					$this->getDirList($v);
					$newflist = array();
					foreach($this->dirlist as $vv ) {
						if( $vv['name'] != '.' && $vv['name'] != '..' ) {
							$newflist[] = $vv['name'];
						}
					}
					if( !empty($newflist) ) {$this->rmFiles($v, $newflist);}	//recurse
					$rmed = @rmdir($v);
				} else {
					$rmed = @unlink($v);
				}

				if( !$rmed ) {$this->result=0; return(false);}		//!!!
			}
			$this->result=1; return(true);					//!!!
		}
		$this->result=0; return(false);						//!!!
	}

}

$zipname = isset($_POST['zipname']) ? $_POST['zipname'] : 'zipname.zip';
$myzip = new zipIt($zipname);

if (isset($_POST["action"])) {
	$originaTimeout = ini_get('max_execution_time');
	set_time_limit (0);
	switch ($_POST["action"]) {
		case "store":
				if( isset($_POST['filelist']) && !empty($_POST['filelist']) ) {
					$myzip->filelist = $_POST["filelist"];
					$myzip->storeFiles();
				}
				break;
		case "extract":
				$myzip->extractFiles();
				break;
		case "rmfiles":
				if( isset($_POST['filelist']) && !empty($_POST['filelist']) ) {
					$myzip->filelist = $_POST["filelist"];
					$myzip->rmFiles();
				}
				break;
	}
	set_time_limit ($originaTimeout);
}

$myzip->getDirList();

?>

<html>
<head>
<style>
body, html {
	margin:0; padding:0; font-family:Verdana, Arial, Tahoma; font-size:12px; background-color:#FFFFFF;}
td, input {
	font-size:12px;
	}
fieldset {
	padding: 5px; margin: 5px; border:1px solid gray;
}
legend {
	padding: 0px 5px; color: black;
}
#store_block, #extract_block, #rmfiles_block  {
	display: none;}
.copyright {
	font-size: 10px; color:#AAAAAA;
}
.switch {
	text-decoration:none; color:red; font-weight:bold;
}
.file_disable {
	color:gray;}
.file_warn {
	color:red}
.file_highlight {
	color:magenta}
.file_normal {
	color:black;}
.cell_directory, .cell_normal, .cell_comment {
	padding: 0px 5px;}
.cell_directory, .cell_normal {
	width: 350px;}
.cell_directory {
	font-weight:bold;}
.cell_normal {
	font-weight:normal;}
.cell_comment {
	color: grey;}
</style>

<script type="text/javascript">
var currentAction = "<?php echo (isset($_POST["action"])) ? $_POST["action"] : "none"; ?>";
function switchAction (action, link_obj) {
	switch (action) {
		case "store":
				obj = document.getElementById('store_block');
				obj.style.display = (obj.style.display == "block") ? "none" : "block";
				link_obj = document.getElementById('store_switch');
				link_obj.innerHTML = (obj.style.display == "block") ? "(-)" : "(+)";
				break;
		case "extract":
				obj = document.getElementById('extract_block');
				obj.style.display = (obj.style.display == "block") ? "none" : "block";
				link_obj = document.getElementById('extract_switch');
				link_obj.innerHTML = (obj.style.display == "block") ? "(-)" : "(+)";
				break;
		case "rmfiles":
				obj = document.getElementById('rmfiles_block');
				obj.style.display = (obj.style.display == "block") ? "none" : "block";
				link_obj = document.getElementById('rmfiles_switch');
				link_obj.innerHTML = (obj.style.display == "block") ? "(-)" : "(+)";
				break;
	}
}

function uncheckAll (formName) {
	for( i=0; i<document.forms.length; i++ ) {
		if( document.forms[i].name == formName ) {
			theform = document.forms[i];
			thetags = theform.getElementsByTagName("INPUT");
			for( a=0; a<thetags.length; a++ ) {
				tag = thetags[a];
				if( tag.type == 'hidden' ) continue;
				if( tag.type != 'checkbox' ) continue;
				if( tag.checked != true ) continue;
				tag.checked = false;
			}
		}
	}
}

</script>
</head>
<body>
<form action="<?php echo basename(__FILE__); ?>" method="POST"  name="store">
<fieldset><legend style="font-weight:bold; color:blue"> Store files <a id="store_switch" class="switch" href="javascript:void(0)" onclick="switchAction('store');">(+)</a></span></legend>
<DIV id="store_block">
	<fieldset><legend>File name</legend>
		<input name="zipname" type="text" size="40" value="<?php echo $zipname ?>" onfocus="if (this.value=='<?php echo $zipname ?>') {this.value=''}" onblur="if (this.value=='') {this.value='<?php echo $zipname ?>'}" />&nbsp;
	</fieldset>
	<fieldset><legend>File list</legend>

		<table cellpadding="0" cellspacing="0" border="0">
<?php
foreach ($myzip->dirlist as $dir_key=>$dir_val) {
	$disabled_files = array('pclzip.lib.php', basename(__FILE__), '.', '..');
	$warning_files = array ('*.log');
	$highlight_files = array ('*.zip', '*.tar', '*.gz', '*.rar');

	$attributes="checked='true'";
	$htmlstr="<span class='file_normal'>" . $dir_val['name'] . "</span>";
	$cellclass="cell_normal";

	if ($myzip->fnmatch($disabled_files, $dir_val['name'])) {
		$attributes="disabled='true'";
		$htmlstr="<span class='file_disable'>" . $dir_val['name'] . "</span>";
	} elseif ($myzip->fnmatch($warning_files, $dir_val['name'])) {
		$attributes="checked='true'";
		$htmlstr="<span class='file_warn'>" . $dir_val['name'] . "</span>";
	} elseif ($myzip->fnmatch($highlight_files, $dir_val['name'])) {
		$attributes="";
		$htmlstr="<span class='file_highlight'>" . $dir_val['name'] . "</span>";
	}
	if ($dir_val['type']=='dir') {
		$cellclass="cell_directory";
	} else {
		$cellclass="cell_normal";
	}


	echo "
			<tr><td class='" . $cellclass . "'>
				<input name='filelist[]' id='store_" . $dir_val['name'] . "' type='checkbox' value='" . $dir_val['name'] . "' " . $attributes . " /><label for='store_" . $dir_val['name'] . "'>" . $htmlstr . "</label>
			</td><td class='cell_comment'>
				" . $dir_val['type'] . "
			</td></tr>";
}
?>
		</table>
	</fieldset>
	<div style="text-align:center">
		<input name="action" type="hidden" value="store" />
		<input type="submit" value="Store!" style="font-weight:bold; color:brown"/>&nbsp;&nbsp;&nbsp;<input type="reset" value="Reset" />&nbsp;&nbsp;&nbsp;<input type="button" value="Uncheck all" onclick="uncheckAll('store');" />
	</div>
</DIV>
</fieldset>
</form>



<form action="<?php echo basename(__FILE__); ?>" method="POST"  name="extract">
<fieldset><legend style="font-weight:bold; color:blue"> Extract files <a id="extract_switch" class="switch" href="javascript:void(0)" onclick="switchAction('extract');">(+)</a></span></legend>
<DIV id="extract_block">
		<table cellpadding="0" cellspacing="0" border="0">
<?php

for ($i=0, $first_found=false; $i < count($myzip->dirlist); $i++) {
	$dir_val=$myzip->dirlist[$i];
	$allowed_files = array('*.zip');
	if ($dir_val['type'] != "file") continue;					//!!! next loop if not a file
	if (!$myzip->fnmatch($allowed_files, $dir_val['name'])) continue;		//!!! next loop if not an allowed file

	$htmlstr="<span class='file_highlight'>" . $dir_val['name'] . "</span>";
	if (!$first_found) {
		$attributes="checked='true'";
		$first_found=true;
	} else {
		$attributes="";
	}

	echo "
			<tr><td class='" . $cellclass . "'>
				<input name='zipname' id='extr_" . $dir_val['name'] . "' type='radio' value='" . $dir_val['name'] . "' " . $attributes . "/><label for='extr_" . $dir_val['name'] . "'>" . $htmlstr . "</label>
			</td><td class='cell_comment'>
				" . $dir_val['type'] . "
			</td></tr>";
}
?>
		</table>
	<div style="text-align:center">
		<input name="action" type="hidden" value="extract" />
		<input type="submit" value="Extract!" style="font-weight:bold; color:brown"/>&nbsp;&nbsp;&nbsp;<input type="reset" value="Reset" />
	</div>
</DIV>
</fieldset>
</form>


<form action="<?php echo basename(__FILE__); ?>" method="POST" name="rmfiles">
<fieldset><legend style="font-weight:bold; color:blue"> Remove files <a id="rmfiles_switch" class="switch" href="javascript:void(0)" onclick="switchAction('rmfiles');">(+)</a></span></legend>
<DIV id="rmfiles_block">
	<fieldset><legend>File list</legend>

		<table cellpadding="0" cellspacing="0" border="0">
<?php
foreach ($myzip->dirlist as $dir_key=>$dir_val) {
	$disabled_files = array('pclzip.lib.php', basename(__FILE__), '.', '..');
	$warning_files = array ('*.log');
	$highlight_files = array ('*.zip', '*.tar', '*.gz', '*.rar');

	$attributes="checked='true'";
	$htmlstr="<span class='file_normal'>" . $dir_val['name'] . "</span>";
	$cellclass="cell_normal";

	if ($myzip->fnmatch($disabled_files, $dir_val['name'])) {
		$attributes="disabled='true'";
		$htmlstr="<span class='file_disable'>" . $dir_val['name'] . "</span>";
	} elseif ($myzip->fnmatch($warning_files, $dir_val['name'])) {
		$attributes="checked='true'";
		$htmlstr="<span class='file_warn'>" . $dir_val['name'] . "</span>";
	} elseif ($myzip->fnmatch($highlight_files, $dir_val['name'])) {
		$attributes="";
		$htmlstr="<span class='file_highlight'>" . $dir_val['name'] . "</span>";
	}
	if ($dir_val['type']=='dir') {
		$cellclass="cell_directory";
	} else {
		$cellclass="cell_normal";
	}


	echo "
			<tr><td class='" . $cellclass . "'>
				<input name='filelist[]' id='rmfiles_" . $dir_val['name'] . "' type='checkbox' value='" . $dir_val['name'] . "' " . $attributes . " /><label for='rmfiles_" . $dir_val['name'] . "'>" . $htmlstr . "</label>
			</td><td class='cell_comment'>
				" . $dir_val['type'] . "
			</td></tr>";
}
?>
		</table>
	</fieldset>
	<div style="text-align:center">
		<input name="action" type="hidden" value="rmfiles" />
		<input type="submit" value="Remove!" style="font-weight:bold; color:brown"/>&nbsp;&nbsp;&nbsp;<input type="reset" value="Reset" />&nbsp;&nbsp;&nbsp;<input type="button" value="Uncheck all" onclick="uncheckAll('rmfiles');" />
	</div>
</DIV>
</fieldset>
</form>


<fieldset><legend>Messages</legend>
<?php

	$message = 'No messages!';
	if (isset($_POST["action"])) {
	 	switch ($_POST["action"]) {
	 		case "store":
	 			$message = ($myzip->result!=0) ? "Files have been stored (" . $zipname . ")" : "Failed to store files (" . $zipname . ")";
	 			break;
	 		case "extract":
	 			$message = ($myzip->result!=0) ? "Files have been extracted (" . $zipname . ")"  : "Failed to extract files (" . $zipname . ")";
	 			break;
	 		case "rmfiles":
	 			$message = ($myzip->result!=0) ? "Files have been removed"  : "Failed to remove files";
	 			break;
	 		default:
		}
	}
	echo $message;
?>
</fieldset>


<script type="text/javascript">
	switch (currentAction) {
		case "store":
			switchAction("store");
			break;
		case "extract":
			switchAction("extract");
			break;
		case "rmfiles":
			switchAction("rmfiles");
			break;
		default:
	}
</script>
<p class="copyright"><?php echo $copyright ?></p>
</body>
</html>